/* Includes ------------------------------------------------------------------*/
//#include <__cross_studio_io.h>
//#include <stdlib.h>
//#include <stdint.h>
#include <stdio.h>
//#include "hardware.h"
#include "stm32l0xx.h"
#include "stm32l011xx.h"


static __IO uint32_t tick; // __IO "volatile" expression from core_cm0plus.h

/* Time-out values */
static const uint32_t HSI_TIMEOUT_VALUE = 100;  /* 100 ms */
static const uint32_t PLL_TIMEOUT_VALUE = 100;  /* 100 ms */
static const uint32_t CLOCKSWITCH_TIMEOUT_VALUE = 500; /* 500 ms    */

/* Error codes used to make the red led blinking */
#define ERROR_HSI_TIMEOUT 0x01
#define ERROR_PLL_TIMEOUT 0x02
#define ERROR_CLKSWITCH_TIMEOUT 0x03

int init_clocks(void);
//Hardware hw(42);

/* MAIN ------------------------------------------------------------------*/
int main(void)
{
  //debug_printf("Hello\n");
  printf("Hello\n");
  SysTick_Config(1000);

  RCC->APB1ENR |= (RCC_APB1ENR_PWREN); //Enable Clock for APB1

  init_clocks();

 if(tick<1000){
    printf("HERE\n");
  }

 // hw.init_hardware(); 
  //debug_exit(0);
}

extern "C" void SysTick_Handler(void)
  {
    tick++;
  }

int init_clocks()    
{ 
  uint32_t tickstart;
  tickstart = tick;
  RCC->CR |= RCC_CR_HSION | RCC_CR_HSIDIVEN; //enable HSI and divide by 4 --> 4MHz
  while( (RCC_CFGR_SWS & RCC_CR_HSIRDY) == 0){ //wait for HSI is ready
    if( (tick - tickstart) > HSI_TIMEOUT_VALUE )
      return ERROR_HSI_TIMEOUT;
  } 

  tickstart = tick;
  RCC->CFGR |= RCC_CFGR_SW_HSI | RCC_CFGR_HPRE_3 ; //set HSI as sysclock source in sysclock MUX and AHB prescaler to 2
  while( (RCC_CFGR_SWS & RCC_CFGR_SWS_HSI) == 0){ //wait for HSI is selected
    if( (tick - tickstart) > HSI_TIMEOUT_VALUE )
      return ERROR_HSI_TIMEOUT;
  } 
}